<?php

namespace Drupal\monarch_map\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'svg_map_data_default' formatter.
 *
 * @FieldFormatter(
 *   id = "svg_map_data_default",
 *   label = @Translation("Default"),
 *   field_types = {"svg_map_data"}
 * )
 */
class SvgMapDataDefaultFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $element[0]['app'] = [
      '#type' => 'html_tag',
      '#tag' => 'div',
      '#attributes' => [
        'data-vue-app' => 'svg-user-map',
        'data-vue-data' => $items->value ?? NULL ?: '{}',
      ],
    ];

    $element[0]['app']['#attached']['library'][] = 'monarch_map/svg_map_user_app';
    $element[0]['app']['#attached']['drupalSettings']['svgMap']['defaultUnderlayColor'] = '#ddd';
    $element[0]['app']['#attached']['drupalSettings']['svgMap']['defaultUnderlayStrokeColor'] = 'transparent';

    return $element;
  }

}
