<?php

namespace Drupal\monarch_map;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\user\EntityOwnerInterface;
use Drupal\Core\Entity\EntityChangedInterface;

/**
 * Provides an interface defining a svg map entity type.
 */
interface SvgMapInterface extends ContentEntityInterface, EntityOwnerInterface, EntityChangedInterface {

  /**
   * Gets the svg map title.
   *
   * @return string
   *   Title of the svg map.
   */
  public function getTitle();

  /**
   * Sets the svg map title.
   *
   * @param string $title
   *   The svg map title.
   *
   * @return \Drupal\monarch_map\SvgMapInterface
   *   The called svg map entity.
   */
  public function setTitle($title);

  /**
   * Gets the svg map creation timestamp.
   *
   * @return int
   *   Creation timestamp of the svg map.
   */
  public function getCreatedTime();

  /**
   * Sets the svg map creation timestamp.
   *
   * @param int $timestamp
   *   The svg map creation timestamp.
   *
   * @return \Drupal\monarch_map\SvgMapInterface
   *   The called svg map entity.
   */
  public function setCreatedTime($timestamp);

  /**
   * Returns the svg map status.
   *
   * @return bool
   *   TRUE if the svg map is enabled, FALSE otherwise.
   */
  public function isEnabled();

  /**
   * Sets the svg map status.
   *
   * @param bool $status
   *   TRUE to enable this svg map, FALSE to disable.
   *
   * @return \Drupal\monarch_map\SvgMapInterface
   *   The called svg map entity.
   */
  public function setStatus($status);

}
